;;;; run.scm


(use progress-indicators srfi-18)

(let ((s (make-progress-bar)))
  (do ((i 0 (add1 i)))
      ((>= i 100))
    (advance-progress-bar! s))
  (finish-progress-bar! s))

(define (spin n t thunk)
  (do ((i n (sub1 i)))
      ((negative? i))
    (thunk)
    (thread-sleep! t)))

(let ((s (make-progress-bar max: 20000000)))
  (spin 
   20 0.1 
   (lambda ()
     (advance-progress-bar! s (/ 20000000 20))))
  (finish-progress-bar! s))

(print "clear:")

(let ((s (make-progress-bar max: 100)))
  (spin 
   20 0.1
   (lambda ()
     (advance-progress-bar! s (/ 100 20))))
  (finish-progress-bar! s #t))

(let ((s (make-spinner)))
  (spin 20 0.1 (cut advance-spinner! s))
  (finish-spinner! s))

